
using GatewaySCO;
/// <summary>
/// Factory que retorna un directorio de comandos instanciado
/// con los comandos apropiados según tipo de POS.
/// </summary>
public class DirectorioCmdsFactory
    {
        public static CreaDirectorioCmds CreaDirectorio(string tipoPOS)
        {
        return tipoPOS switch
        {
            "ECO" => DispensaDirectorioCmdsPruebas.Dispensa(),
            "POSBC" =>  DispensaDirectorioCmdsPOSBC.Dispensa(),
            "POSBCTest" =>  DispensaDirectorioCmdsPOSBCTest.Dispensa(),
            "evapos" => DispensaDirectorioCmdsEvaPOS.Dispensa(),
            "gk" => DispensaDirectorioCmdsGK.Dispensa(),
            "gk_test" => DispensaDirectorioCmdsGKPruebas.Dispensa(),
            _ => throw new ArgumentException($"Valor no reconocido en archivo configuración, parámetro 'POS', con valor {tipoPOS}.", tipoPOS),
        };
    }
    }
