using System.Xml;
using EvaPosSCOSrv;
using EvaPosSrvAplicacion;
using EvaPosSrvAplicacionImp;
using EvaPosSrvResp;
using EvaPosSrvRespImp;
using GatewaySCO;
using Serilog;

namespace Servidor.TcpGateway;

public class MessageProcessor
{
    public DirectorioAdaptadoresDTO Adaptadores { get; set; }
    public CreaDirectorioCmds Comandos { get; set; }
    public Sesion Sesion { get; set; }
    public Presentacion Presentacion { get; set; }
    public IAplicacion Aplicacion { get; set; }

    public MessageProcessor()
    {
        string tipoPOS = Entorno<Config>.Instancia.Get().POS;
        Adaptadores = IniciaDirectorioAdaptadores.Cargar().DirectorioAdaptadores;
        Comandos = DirectorioCmdsFactory.CreaDirectorio(tipoPOS);
        Aplicacion = new Aplicacion();
    }

    public void MessageFromCHEC(byte[] buffer, int length)
    {
        // Procesando entrada: se obtiene mensaje, con el cual se 
        // identifica comando que lo procesa.
        TramaSCO msj = Sesion.Entrada(buffer, length);
        Log.Debug("MessageProcessor CHEC-POSBC tipo {tipo}, id sesión {id}, xml \n{xml}", msj.TipoMensaje.Tipo, msj.IdSesion, msj.TextoXML);
        //IComando cmd = Presentacion.Entrada(msj);
        // if (cmd.Referencia == "scsns:Terminate")
        // {
        // }
    }

    // Detecta mensaje de finalización de POSBC y retorna false si lo encuentra (no continuar)
    public bool MessageFromPOSBCToCHEC(byte[] buffer, int length)
    {
        TramaSCO msj = Sesion.Entrada(buffer, length);
        Log.Debug("MessageProcessor POSBC-CHEC tipo {tipo}, id sesión {id}, xml \n{xml}", msj.TipoMensaje.Tipo, msj.IdSesion, msj.TextoXML);

        // Consultar si el elemento TerminateResult está presente
        // XmlDocument xmlDoc = msj.ContenidoXML;
        // XmlNamespaceManager nsmgr = new XmlNamespaceManager(xmlDoc.NameTable);
        // nsmgr.AddNamespace("schema", "http://bc.si.retail.ibm.com/POSBCSchema");

        // XmlNode terminateResultNode = xmlDoc.SelectSingleNode("TerminateResult", nsmgr);
        // if (terminateResultNode != null)
        // {
        //     Log.Debug("El elemento TerminateResult está presente.");
        //     return false;
        // }

        if (msj.TextoXML.Contains("<TerminateResult>"))
        {
            Log.Debug("Mensaje <TerminateResult> identificado.");
            return false;
        }

        return true;
    }
}